/*!
 * @file bsp_entity.h
 * @brief description
*/

#ifndef _BSP_ENTITY_H
#define _BSP_ENTITY_H

#include "world_entity.h"
#include "bsp_manager.h"

#include "util/loading/factory.h"
#include "util/loading/load_param.h"



//! A Class to ...
class BSPEntity : public WorldEntity
{
 
 public:
  BSPEntity(const TiXmlElement* root = NULL);
  virtual ~BSPEntity();

  virtual void loadParams(const TiXmlElement* root);
  
  void setName(const std::string& name);

  void init();

  virtual void draw() const;
  virtual void tick(float time);
  virtual void collidesWith (WorldEntity* entity, const Vector& location);

 private:
   BspManager* bspManager;

};

#endif /* _BSP_ENTITY_H */
